// BTPayDemoDlg.cpp : implementation file
//

//#include "afxwin.h"
#include "stdafx.h"
#include "BTPayDemo.h"
#include "BTPayDemoDlg.h"
#include "BTPay_SDK.h"
#include "DlgInterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CBTPayDemoDlg * s_thisDlg = NULL;
static CDlgInterface * s_dlgInterface = NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBTPayDemoDlg dialog

CBTPayDemoDlg::CBTPayDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBTPayDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBTPayDemoDlg)
	m_editAPDU = _T("");
	m_strDrectIO = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	s_thisDlg = this;
	s_dlgInterface = new CDlgInterface();
}

void CBTPayDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBTPayDemoDlg)
	DDX_Control(pDX, IDC_EDIT_DIO, m_ctlDirectIO);
	DDX_Control(pDX, IDC_EDIT_APDU, m_ctlAPDU);
	DDX_Text(pDX, IDC_EDIT_APDU, m_editAPDU);
	DDX_Text(pDX, IDC_EDIT_DIO, m_strDrectIO);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBTPayDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CBTPayDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN, OnBtnOpen)
	ON_BN_CLICKED(IDC_BTN_CLOSE, OnBtnClose)
	ON_BN_CLICKED(IDC_BTN_GETFIRMVER, OnBtnGetFirmVersion)
	ON_BN_CLICKED(IDC_BTN_GETSN, OnBtnGetSN)
	ON_BN_CLICKED(IDC_BTN_SETSN, OnBtnSetSN)
	ON_BN_CLICKED(IDC_BTN_GETMODELN, OnBtnGetModelN)
	ON_BN_CLICKED(IDC_BTN_CLEAR, OnBtnClear)
	ON_BN_CLICKED(IDC_BTN_GET_ENCRYPTED_PIN, OnBtnGetEncryptedPin)
	ON_BN_CLICKED(IDC_BTN_CANCELPIN, OnBtnCancelPIN)
	ON_BN_CLICKED(IDC_BTN_ENABLEMSR, OnBtnEnableMSR)
	ON_BN_CLICKED(IDC_BTN_DISABLEMSR, OnBtnDisableMSR)
	ON_BN_CLICKED(IDC_BTN_DISPLAYMSG, OnBtnDisplayMSG)
	ON_BN_CLICKED(IDC_BTN_GETNUMERIC, OnBtnGetNumericKey)
	ON_BN_CLICKED(IDC_BTN_GETAMOUNT, OnBtnGetAmount)
	ON_BN_CLICKED(IDC_BTN_GETACCOUNT, OnBtnGetAccount)
	ON_BN_CLICKED(IDC_BTN_GETENCRYPTEDDATA, OnBtnGetEncryptedData)
	ON_BN_CLICKED(IDC_BTN_GETICCSTATUS, OnBtnGetICC_Status)
	ON_BN_CLICKED(IDC_BTN_POWERON, OnBtnPowerOn)
	ON_BN_CLICKED(IDC_BTN_APDU, OnBtnAPDU)
	ON_BN_CLICKED(IDC_BTN_POWEROFF, OnBtnPowerOff)
	ON_BN_CLICKED(IDC_BTNTEST, OnBtnTest)
	ON_BN_CLICKED(IDC_BTNDIRECTIO, OnBtnDirectIO)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBTPayDemoDlg message handlers

BOOL CBTPayDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBTPayDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBTPayDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBTPayDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBTPayDemoDlg::AddMsg(CString str)
{
	CString strOld = "";
	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDIT_LOG);
	pEdit->GetWindowText(strOld);
	strOld += str;
	pEdit->SetWindowText(strOld);
	pEdit->LineScroll(pEdit->GetLineCount(),0);
}

void CBTPayDemoDlg::AddFailMsg(int nErrCode, CString msg)
{
	CString strOld = "";
	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDIT_LOG);
	pEdit->GetWindowText(strOld);
	strOld += msg +" fail, ";
	CString strSPT = "";
	strSPT.Format("%04x", nErrCode);
	strOld += "errorCode: " + strSPT;
	char errChar[1024] = {0};
	BOOL b = BTPay_comErrorCodeScript(nErrCode, errChar);
	if (b)
	{
		CString strSPT = errChar;
		strOld += ", " +strSPT;
	}
	strOld += "\r\n";
	pEdit->SetWindowText(strOld);
	pEdit->LineScroll(pEdit->GetLineCount(),0);
}

void CBTPayDemoDlg::SetMsg(CString str)
{
	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDIT_LOG);
	pEdit->SetWindowText(str);
	pEdit->LineScroll(pEdit->GetLineCount(),0);
}

void CBTPayDemoDlg::OnBtnClear() 
{
	// TODO: Add your control notification handler code here
	SetMsg("");
}

void CBTPayDemoDlg::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	if (NULL == s_dlgInterface)
	{
		return;
	}
	int nFlag = s_dlgInterface->DoModal();
	if (IDOK != nFlag)
	{
		return;
	}
	int nInterface = s_dlgInterface->m_nIntface;
	int nSerialPort = s_dlgInterface->m_nComN;
	
	BOOL b = BTPay_Open(nInterface, nSerialPort); // INTERFACE_BLUETOOTH, 7);
	
	if (!b)
	{
		AddMsg("open fail.\r\n");
	}
	else
	{
		AddMsg("Opened.\r\n");
	}
}

void CBTPayDemoDlg::OnBtnClose() 
{
	// TODO: Add your control notification handler code here
	BTPay_msrDisableMSR();
	BTPay_pinCancelPin();
	BTPay_Close();
	AddMsg("Closed.\r\n");
}

void CBTPayDemoDlg::OnBtnGetFirmVersion() 
{
	// TODO: Add your control notification handler code here
	char cFirm[100] = {0};
	int nCode = BTPay_comGetFirmwareVersion(cFirm);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		str = cFirm;
		AddMsg("GetFirm: "+str+"\r\n");
		return;
	}
	AddFailMsg(nCode, "GetFirm");
//	str.Format("error: %04X", nCode);
//	AddMsg("GetFirm, "+str+"\r\n");
}

void CBTPayDemoDlg::OnBtnGetSN() 
{
	// TODO: Add your control notification handler code here
	char cSN[100] = {0};
	int nCode = BTPay_comGetSerialNumber(cSN);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		str = cSN;
		AddMsg("GetSerialNumber: "+str+"\r\n");
		return;
	}
	AddFailMsg(nCode, "GetSerialNumber");
//	str.Format("error: %04X", nCode);
//	AddMsg("GetSerialNumber, "+str+"\r\n");
	
}

void CBTPayDemoDlg::OnBtnSetSN() 
{
	// TODO: Add your control notification handler code here
	char cSN[11] = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 0};
	int nCode = BTPay_comSetSerialNumber(cSN);
	CString str = cSN;
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("SetSerialNumber as ("+str+":) OK.\r\n");
		return;
	}
	str.Format("GetSerialNumber as (%s)", str);
	AddFailMsg(nCode, str);
	
}

void CBTPayDemoDlg::OnBtnGetModelN() 
{
	// TODO: Add your control notification handler code here
	char cMN[100] = {0};
	int nCode = BTPay_comGetModelNumber(cMN);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		str = cMN;
		AddMsg("GetModelNumber: "+str+"\r\n");
		return;
	}
	AddFailMsg(nCode, "GetModelNumber");
	
}

void __stdcall CallBack_Event_EnryptedPIN (int nDataType, BYTE *data, int dataLen)
{
	CString strTp = "";
	switch(nDataType)
	{
	case TYPE_EVENT_PIN_INPUT_DATA:
		strTp = "INPUT_DATA";
		break;
	case TYPE_EVENT_PIN_CANCEL:
		strTp = "CANCEL";
		break;
	case TYPE_EVENT_PIN_TIMEOUT:
		strTp = "TIMEOUT";
		break;
	case TYPE_EVENT_UNKNOWN:
		strTp = "UNKNOWN";
		break;
	default:
		strTp = "OTHER";
	}

	CString strData = "";
	CString str;
	
	for(int i = 0; i < dataLen; i++)
	{	
		str.Format("%02X ",data[i]);
		strData += str;
	}

	s_thisDlg->AddMsg("Event, EnryptedPIN recieved: "+strTp+"\r\n  data: "+strData+"\r\n");
}

void CBTPayDemoDlg::OnBtnGetEncryptedPin() 
{
	BTPay_pinAddCallBack_EncryptedPin(CallBack_Event_EnryptedPIN);

	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "Enter";
	char *line3 = "PIN:";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line3);
	memcpy(msg + nMsgLen, line3, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;
	msg[nMsgLen] = 0;

	char *acc = "1234567890123456";
	int nCode = BTPay_pinGetEncryptedPin(0x01, acc, msg);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetEncryptedPin: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetEncryptedPin");
	
}

void CBTPayDemoDlg::OnBtnCancelPIN() 
{
	// TODO: Add your control notification handler code here
	int nCode = BTPay_pinCancelPin();
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("CancelPIN: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "CancelPIN, ");
	
}

void __stdcall CallBack_Event_MSR (int nDataType, BYTE *dataCard, int dataLen)
{
	//CBTPayDemoDlg* pthis = (CBTPayDemoDlg*)pParam;
	//pthis->m_MsrData = "";
	CString strCard = "";
	CString str;
	
	for(int i = 0; i < dataLen; i++)
	{	
		str.Format("%02X ",dataCard[i]);
		strCard += str;
	}

	switch(nDataType)
	{
	case TYPE_EVENT_MSR_CARD_DATA:
		str = "card";
		break;
	case TYPE_EVENT_MSR_CANCEL_KEY:
		str = "CANCEL KEY,";
		break;
	case TYPE_EVENT_MSR_BACKSPACE_KEY:
		str = "BACKSPACE KEY,";
		break;
	case TYPE_EVENT_MSR_ENTER_KEY:
		str = "ENTER KEY,";
		break;
	case TYPE_EVENT_MSR_UNKNOWN:
		str = "UNKNOWN,";
		break;
	default:
		str = "OTHER";
		;
	}
	
	s_thisDlg->AddMsg("MSR Event,"+ str +" data: \r\n"+strCard+"\r\n");
}

void CBTPayDemoDlg::OnBtnEnableMSR() 
{
	BTPay_msrAddCallBack_MSR(CallBack_Event_MSR);

	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "swipe";
	char *line3 = "your card";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line3);
	memcpy(msg + nMsgLen, line3, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;
	msg[nMsgLen] = 0;

	int nCode = BTPay_msrEnableMSR(msg);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("Enable MSR: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "Enable MSR");
	
}

void CBTPayDemoDlg::OnBtnDisableMSR() 
{
	// TODO: Add your control notification handler code here
	int nCode = BTPay_msrDisableMSR();
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("Disable MSR: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "Disable MSR");
	
}

void CBTPayDemoDlg::OnBtnDisplayMSG() 
{
	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "note";
	char *line3 = "this message:";
	char *line4 = "IDTECH.BTPay200.";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line3);
	memcpy(msg + nMsgLen, line3, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line4);
	memcpy(msg + nMsgLen, line4, nLenTmp);
	nMsgLen += nLenTmp;

	msg[nMsgLen] = 0;

	int nCode = BTPay_comDisplayMessage(msg);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("DisplayMessage: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "DisplayMessage");

}

BOOL byte2Hex(BYTE* src, int nSrcLen, CString &retStr)
{
	if (nSrcLen<1) 
	{
		return FALSE;
	}
	CString strTmp = "";
	for (int i=0; i<nSrcLen; i++)
	{
		strTmp.Format("%02X", src[i]);
		retStr += strTmp;
	}

	return TRUE;
}

BOOL ReadMSRPrivateKeys(R_RSA_PRIVATE_KEY *Private_key)
{
	FILE *file;
	unsigned int state;
 
    if((file = fopen ("PrivateKey2048.bin", "rb")) == NULL)   /* successfully opened */
	   return FALSE;
	int nSize = sizeof(R_RSA_PRIVATE_KEY);
	BYTE buff[8400] = {0};
	state = fread(buff, nSize, 1, file);
    if(state != 1) return FALSE;
	
	state = fread(buff, nSize, 1, file);
    if(state != 1) return FALSE;
	int ntp = nSize/4;
//	CString str = "";
//	byte2Hex(buff, ntp, str);
//	OutputDebugString("ras2 1): "+str+"\r\n");
//	str = "";
//	byte2Hex(buff + ntp*3, ntp+2, str);
//	OutputDebugString("ras2 4): "+str+"\r\n");

	memcpy(Private_key, buff, nSize);

	fclose(file);
	return TRUE;
}

void __stdcall CallBack_Event_Numeric (int nDataType, BYTE *data, int dataLen)
{
	CString strTp = "";
	switch(nDataType)
	{
	case TYPE_EVENT_PIN_INPUT_DATA:
		strTp = "NUMERIC_DATA";
		break;
	case TYPE_EVENT_PIN_CANCEL:
		strTp = "CANCEL";
		break;
	case TYPE_EVENT_PIN_TIMEOUT:
		strTp = "TIMEOUT";
		break;
	case TYPE_EVENT_UNKNOWN:
		strTp = "UNKNOWN";
		break;
	default:
		strTp = "OTHER";
	}

	CString strData = "";
	CString str;
	
	for(int i = 0; i < dataLen; i++)
	{	
		str.Format("%02X ",data[i]);
		strData += str;
	}

	s_thisDlg->AddMsg("Event, Numeric recieved: "+strTp+"\r\n  data: "+strData+"\r\n");
}

void CBTPayDemoDlg::OnBtnGetNumericKey() 
{
	BTPay_pinAddCallBack_Numeric(CallBack_Event_Numeric);

	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "Input Numeric";
	//char *line3 = ":";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	msg[nMsgLen] = 0x1C;
	nMsgLen++;
	msg[nMsgLen] = 0;

	BYTE max_len = 0x0C;
	BYTE min_len = 0x04;
	//char *acc = "1234567890123456";
	
	R_RSA_PRIVATE_KEY *rasKey = new R_RSA_PRIVATE_KEY();
	BOOL b = ReadMSRPrivateKeys(rasKey);
	if (!b)
	{
		AfxMessageBox("not find the RAS key.");
		return;
	}

	int nCode = BTPay_pinGetNumeric(0, max_len, min_len, msg, rasKey);
	delete(rasKey);	
	
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetNumericKey: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetNumericKey");
	
}

void __stdcall CallBack_Event_Amount (int nDataType, BYTE *data, int dataLen)
{
	CString strTp = "";
	switch(nDataType)
	{
	case TYPE_EVENT_PIN_INPUT_DATA:
		strTp = "AMOUNT_DATA";
		break;
	case TYPE_EVENT_PIN_CANCEL:
		strTp = "CANCEL";
		break;
	case TYPE_EVENT_PIN_TIMEOUT:
		strTp = "TIMEOUT";
		break;
	case TYPE_EVENT_UNKNOWN:
		strTp = "UNKNOWN";
		break;
	default:
		strTp = "OTHER";
	}

	CString strData = "";
	CString str;
	
	for(int i = 0; i < dataLen; i++)
	{	
		str.Format("%02X ",data[i]);
		strData += str;
	}

	s_thisDlg->AddMsg("Event, Amount recieved: "+strTp+"\r\n  data: "+strData+"\r\n");
}


void CBTPayDemoDlg::OnBtnGetAmount() 
{
	BTPay_pinAddCallBack_Amount(CallBack_Event_Amount);

	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "Input Amount";
	//char *line3 = ":";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	msg[nMsgLen] = 0x1C;
	nMsgLen++;
	msg[nMsgLen] = 0;

	BYTE max_len = 0x0F;
	BYTE min_len = 0x03;
	
	R_RSA_PRIVATE_KEY *rasKey = new R_RSA_PRIVATE_KEY();
	BOOL b = ReadMSRPrivateKeys(rasKey);
	if (!b)
	{
		AfxMessageBox("not find the RAS key.");
		return;
	}

	int nCode = BTPay_pinGetAmount(max_len, min_len, msg, rasKey);
	delete(rasKey);	
	
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetAmount: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetAmount");
	
}

void __stdcall CallBack_Event_Account (int nDataType, BYTE *data, int dataLen)
{
	CString strTp = "";
	switch(nDataType)
	{
	case TYPE_EVENT_PIN_INPUT_DATA:
		strTp = "ACCOUNT_DATA";
		break;
	case TYPE_EVENT_PIN_CANCEL:
		strTp = "CANCEL";
		break;
	case TYPE_EVENT_PIN_TIMEOUT:
		strTp = "TIMEOUT";
		break;
	case TYPE_EVENT_UNKNOWN:
		strTp = "UNKNOWN";
		break;
	default:
		strTp = "OTHER";
	}

	CString strData = "";
	CString str;
	
	for(int i = 0; i < dataLen; i++)
	{	
		str.Format("%02X ",data[i]);
		strData += str;
	}

	s_thisDlg->AddMsg("Event Account recieved: "+strTp+"\r\n  data: "+strData+"\r\n");

}

void CBTPayDemoDlg::OnBtnGetAccount() 
{
	BTPay_pinAddCallBack_Account(CallBack_Event_Account);

	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "Input Account";
	//char *line3 = ":";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;
	msg[nMsgLen] = 0;

	BYTE max_len = 0x14;
	BYTE min_len = 0x0C;
	
	int nCode = BTPay_pinGetAccount(max_len, min_len, msg);
	
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetAccount: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetAccount");
	
}

void __stdcall CallBack_Event_EncryptedData (int nDataType, BYTE *data, int dataLen)
{
	CString strTp = "";
	switch(nDataType)
	{
	case TYPE_EVENT_PIN_INPUT_DATA:
		strTp = "ENCRYPTED_DATA";
		break;
	case TYPE_EVENT_PIN_CANCEL:
		strTp = "CANCEL";
		break;
	case TYPE_EVENT_PIN_TIMEOUT:
		strTp = "TIMEOUT";
		break;
	case TYPE_EVENT_UNKNOWN:
		strTp = "UNKNOWN";
		break;
	default:
		strTp = "OTHER";
	}

	CString strData = "";
	CString str;
	
	for(int i = 0; i < dataLen; i++)
	{	
		str.Format("%02X ",data[i]);
		strData += str;
	}

	s_thisDlg->AddMsg("Event EncryptedData recieved: "+strTp+"\r\n  data: "+strData+"\r\n");
}

void CBTPayDemoDlg::OnBtnGetEncryptedData() 
{
	BTPay_pinAddCallBack_EncryptedData(CallBack_Event_EncryptedData);

	// TODO: Add your control notification handler code here
	char *line1 = "Please";
	char *line2 = "Input Data";
	//char *line3 = ":";
	char msg[100];
	int nMsgLen = 0;
	int nLenTmp = strlen(line1);
	memcpy(msg, line1, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	nLenTmp = strlen(line2);
	memcpy(msg + nMsgLen, line2, nLenTmp);
	msg[nMsgLen + nLenTmp] = 0x1C;
	nMsgLen += nLenTmp + 1;

	msg[nMsgLen] = 0x1C;
	nMsgLen++;
	msg[nMsgLen] = 0;

	BYTE max_len = 0x0F;
	BYTE min_len = 0x03;
	
	R_RSA_PRIVATE_KEY *rasKey = new R_RSA_PRIVATE_KEY();
	BOOL b = ReadMSRPrivateKeys(rasKey);
	if (!b)
	{
		AfxMessageBox("not find the RAS key.");
		return;
	}

	int nCode = BTPay_pinGetEncryptedData(1, max_len, min_len, msg, rasKey);
	delete(rasKey);	
	
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetEncryptedData: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetEncryptedData");
	
}

void CBTPayDemoDlg::OnBtnGetICC_Status() 
{
	// TODO: Add your control notification handler code here
	BYTE by = 0;
	int nCode = BTPay_smartGetICCReaderStatus(by);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		str.Format(" %02X", by);
		AddMsg("GetICC_Status: "+str+".\r\n");

		if ((0x02 & by) == (BYTE)0x02)
		{
			AddMsg(" --> IC Card seated. ");
		}
		else
		{
			AddMsg(" --> No IC Card in reader.\r\n");
			return;
		}

		if ((0x01 & by) == (BYTE)0x01)
		{
			AddMsg(" Power on already.\r\n");
		}

		return;
	}
	AddFailMsg(nCode, "GetICC_Status");
}

void CBTPayDemoDlg::OnBtnPowerOn() 
{
	// TODO: Add your control notification handler code here
	BYTE byATR[512] = {0};
	int atrLen = 0;
	int nCode = BTPay_smartPowerOn(NULL, 0, NULL, 0, byATR, atrLen);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("ICC PowerOn: OK. ");
		//ATR
		CString strData = "";
		CString strT;
		for(int i = 0; i < atrLen; i++)
		{	
			strT.Format("%02X ",byATR[i]);
			strData += strT;
		}
		AddMsg("----ATR: "+strData+".\r\n");
		
		return;
	}
	AddFailMsg(nCode, "ICC PowerOn");
}

void CBTPayDemoDlg::OnBtnPowerOff() 
{
	// TODO: Add your control notification handler code here
	int nCode = BTPay_smartPowerOff();
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("ICC PowerOff: OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetICC_Status");
}


BOOL str2Hex(char x, BYTE &by)
{
	switch(x)
	{
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			by=x-'0';
			break;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
			by=10+x-'A';
			break;
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
			by=10+x-'a';
			break;
		default:
			by = 0;
			return FALSE;
	}
	return TRUE;
}



int convertHexStringToBytes(IN CString str, OUT BYTE *byData, OUT int &nDataLen)
{
	int len = str.GetLength();
	if (len<1)
	{
		nDataLen = 0;
		return 1;
	}
	if (NULL == byData) {
		len = 0;
		return 1;
	}
	//remove the space
	CString strData = "";
	for (int n=0;n<len;n++)
	{
		if (' ' == str[n])
		{
		}
		else
		{
			strData += str[n];
		}
	}

	len = strData.GetLength();
	if (len>1024)
	{
		nDataLen = 0;
		return 2; //too long
	}

	if (1==(len%2))
	{
		nDataLen = 0;
		return 3; //format not good
	}
	
	nDataLen = 0;
	BOOL bRet = TRUE;
	BYTE byTmp1=0,byTmp2=0;
	for(int i=0;i<len;i=i+2)
	{
		if(str2Hex(strData[i], byTmp1))
		{
			if (str2Hex(strData[i+1], byTmp2))
			{
				byData[nDataLen] = byTmp1*16 + byTmp2;
				nDataLen++;
			}
			else
			{
				bRet = FALSE;
				break;
			}
		}
		else
		{
			bRet = FALSE;
			break;
		}
	}
	if (!bRet) 
	{
		return 4; //have error char
	}

	return 0;
}

void CBTPayDemoDlg::OnBtnAPDU() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_editAPDU.IsEmpty())
	{
		MessageBox("Please input APDU.","BTPay");
		m_ctlAPDU.SetFocus();
		return;
	}
	BYTE byAPDU[1024] = {0};
	int nLen = 0;
	int nRt = convertHexStringToBytes(m_editAPDU, byAPDU, nLen);
	if (0 != nRt) //not OK
	{
		MessageBox("Invalid APDU.","BTPay");
		m_ctlAPDU.SetFocus();
		return;
	}
	if (nLen == 0) {
		MessageBox("Invalid APDU.","BTPay");
		m_ctlAPDU.SetFocus();
		return;
	}

	CString strData = "";
	CString strT="";
	int i = 0;
	for(; i < nLen; i++)
	{	
		strT.Format("%02X ",byAPDU[i]);
		strData += strT;
	}
	AddMsg("ExchangeAPDU ->\r\n");
	AddMsg("----CAPDU: "+strData+".\r\n");

	int nCode = BTPay_smartExchangeAPDU(byAPDU, nLen);
	CString str = "";
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("ExchangeAPDU: OK. ");
		//RAPDU
		strData = "";
		strT="";
		for(i = 0; i < nLen; i++)
		{	
			strT.Format("%02X ",byAPDU[i]);
			strData += strT;
		}
		AddMsg("----RAPDU: "+strData+".\r\n");
		
		return;
	}
	AddFailMsg(nCode, "ExchangeAPDU");

}

void CBTPayDemoDlg::OnBtnTest() 
{
	char *a = NULL;
	CString str3 = a;
	MessageBox(str3, "MSG");
	return;

	// TODO: Add your control notification handler code here
	int nCode = -1;

	BYTE data[1024] = {0x78, 0x46, 0x31, 0x00};
	int dLen = 3;
	nCode = BTPay_comDirectIO(data, dLen);
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("DirectIO OK.\r\n");
		CString strT="";
		byte2Hex(data, dLen, strT);
		AddMsg("respose data: "+strT+"\r\n");
		return;
	}
	AddFailMsg(nCode, "DirectIO");
	return;

	//////////
	int by1 = -1;
	int by2 = -1;
	nCode = BTPay_pinGetPinLength(by1, by2);
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetPinLength OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetPinLength");
	return;

	
	char ch1 = 0;
	nCode = BTPay_msrGetMSR_dataFormat(ch1);
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetMSR_dataFormat OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "GetMSR_dataFormat");
	return;



	nCode = BTPay_comEnterSleepMode();
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("EnterSleepMode OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "EnterSleepMode");

	return;

	//////////////////////////////////////////////////////////////
	nCode = BTPay_comRebootDevice();
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("RebootDevice OK.\r\n");
		return;
	}
	AddFailMsg(nCode, "RebootDevice");

	return;

	//////////////////////////////////////////////////////////////
	char chStr[128] = {0};
	nCode = BTPay_comGetDateTime(chStr);
	CString str = chStr;
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("GetDateTime: "+str+".\r\n");
		
		return;
	}
	AddFailMsg(nCode, "ExchangeAPDU");
	return;

//	CString cstr = "ABC";
//	char *p = (LPSTR)(LPCTSTR)cstr; 
//	char a[4] = {0,1,2,3};
//	int len = cstr.GetLength();
//	memcpy(a, p, cstr.GetLength());
//	a[len] = 0;
//	int i = a[3];
}

BOOL CBTPayDemoDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if (s_dlgInterface)
	{
		delete(s_dlgInterface);
		s_dlgInterface = NULL;
	}

	return CDialog::DestroyWindow();
}

void CBTPayDemoDlg::OnBtnDirectIO() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	if (m_strDrectIO.IsEmpty())
	{
		MessageBox("Please input APDU.","BTPay");
		m_ctlDirectIO.SetFocus();
		return;
	}
	
	BYTE data[1024] = {0};//{0x78, 0x46, 0x31, 0x00};
	int dLen = 0;
	int nRt = convertHexStringToBytes(m_strDrectIO, data, dLen);
	if (0 != nRt) //not OK
	{
		MessageBox("Invalid Command.","BTPay");
		m_ctlDirectIO.SetFocus();
		return;
	}
	if (dLen == 0) {
		MessageBox("Invalid Command.","BTPay");
		m_ctlDirectIO.SetFocus();
		return;
	}


	int nCode = BTPay_comDirectIO(data, dLen);
	if (RET_DO_SUCCESS == nCode) 
	{
		AddMsg("DirectIO OK.\r\n");
		CString strT="";
		byte2Hex(data, dLen, strT);
		AddMsg("respose data: "+strT+"\r\n");
		return;
	}
	AddFailMsg(nCode, "DirectIO");
	return;
	
}
