// BTPayDemoDlg.h : header file
//

#if !defined(AFX_BTPAYDEMODLG_H__89113606_9598_4F91_8D40_8849ABE404D8__INCLUDED_)
#define AFX_BTPAYDEMODLG_H__89113606_9598_4F91_8D40_8849ABE404D8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CBTPayDemoDlg dialog

class CBTPayDemoDlg : public CDialog
{
// Construction
public:
	CBTPayDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBTPayDemoDlg)
	enum { IDD = IDD_BTPAYDEMO_DIALOG };
	CEdit	m_ctlDirectIO;
	CEdit	m_ctlAPDU;
	CString	m_editAPDU;
	CString	m_strDrectIO;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBTPayDemoDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBTPayDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnOpen();
	afx_msg void OnBtnClose();
	afx_msg void OnBtnGetFirmVersion();
	afx_msg void OnBtnGetSN();
	afx_msg void OnBtnSetSN();
	afx_msg void OnBtnGetModelN();
	afx_msg void OnBtnClear();
	afx_msg void OnBtnGetEncryptedPin();
	afx_msg void OnBtnCancelPIN();
	afx_msg void OnBtnEnableMSR();
	afx_msg void OnBtnCancelMSR();
	afx_msg void OnBtnDisableMSR();
	afx_msg void OnBtnDisplayMSG();
	afx_msg void OnBtnGetNumericKey();
	afx_msg void OnBtnGetAmount();
	afx_msg void OnBtnGetAccount();
	afx_msg void OnBtnGetEncryptedData();
	afx_msg void OnBtnGetICC_Status();
	afx_msg void OnBtnPowerOn();
	afx_msg void OnBtnAPDU();
	afx_msg void OnBtnPowerOff();
	afx_msg void OnBtnTest();
	afx_msg void OnBtnDirectIO();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void SetMsg(CString str);
	void AddFailMsg(int nErrCode, CString msg);

public:
	void AddMsg(CString str);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BTPAYDEMODLG_H__89113606_9598_4F91_8D40_8849ABE404D8__INCLUDED_)
