// DlgInterface.cpp : implementation file
//

#include "stdafx.h"
#include "BTPayDemo.h"
#include "DlgInterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgInterface dialog


CDlgInterface::CDlgInterface(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgInterface::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgInterface)
	m_nIntface = 0;
	m_strComN = _T("3");
	//}}AFX_DATA_INIT
	m_nComN = 3;
}


void CDlgInterface::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgInterface)
	DDX_Control(pDX, IDC_COMBO1, m_ctlCombo1);
	DDX_Radio(pDX, IDC_RADIO1, m_nIntface);
	DDX_CBString(pDX, IDC_COMBO1, m_strComN);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgInterface, CDialog)
	//{{AFX_MSG_MAP(CDlgInterface)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgInterface message handlers

void CDlgInterface::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (0 == m_nIntface)
	{
		m_ctlCombo1.EnableWindow(FALSE);
	}
	else
	{
		m_ctlCombo1.EnableWindow(TRUE);
	}
}

void CDlgInterface::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (0 == m_nIntface)
	{
		m_ctlCombo1.EnableWindow(FALSE);
	}
	else
	{
		m_ctlCombo1.EnableWindow(TRUE);
	}
	
}

void CDlgInterface::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	char * pChar;
	pChar = m_strComN.GetBuffer(m_strComN.GetLength());
	int i=atoi(pChar);
	if (i<=0)
	{
		MessageBox("Invalid serial number!","BTPay", MB_OK|MB_ICONINFORMATION);
		m_ctlCombo1.SetFocus();
		return;
	}
	m_nComN = i;

	CDialog::OnOK();
}

BOOL CDlgInterface::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (0 == m_nIntface)
	{
		m_ctlCombo1.EnableWindow(FALSE);
	}
	else
	{
		m_ctlCombo1.EnableWindow(TRUE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgInterface::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	UpdateData(TRUE);
	
	CDialog::OnClose();
}
